/*

   MemAid, a memorisation tool.
   Copyright (C) 2003 David Calinski
   Portions of the code: Copyright (c) 1996 Karsten Kutza

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307  USA

*/

/* sorts file with data for NN (in ASCII format!) by
 * input interval, number of repetitions, grades, or output interval
 * - useful for manually correcting data.bin
 */
 
#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
#include <string.h>


void print_usage (char *s) {
	printf ("Usage:");
	printf ("%s 1 2 3\n", s);
	printf ("1 - input file\n");
	printf ("2 - output file\n");
	printf ("3 - number (1-4), sorting by which parameter\n");
	return;
}


int main (int argc, char *argv[]) {
	FILE *we, *wy;
	char buf[128], *p, *p1;
	unsigned short i, j, a, b, c, d, al, bl, cl, dl;

	al = bl = cl = dl = 1001;
	
	if (argc < 4) {
		print_usage (argv[0]);
		exit (1);
	}

	we = fopen (argv[1], "r");
	if (!we) {
		printf ("Cannot open %s\n", argv[1]);
		exit (2);
	}

	wy = fopen (argv[2], "r");
	if (wy) {
		printf ("File %s already exist!\n", argv[2]);
		exit (3);
	}

	wy = fopen (argv[2], "w");
	if (!wy) {
		printf ("Cannot open file %s for writing!\n", argv[2]);
		exit (4);
	}

	j = atoi (argv[3]);
	
#define WYP fprintf(wy,"\n%hu,%hu,%hu,%hu",a,b,c,d)
	
	for (i = 0; i < 1000; i++) {
		rewind (we);
		while (fgets (buf, 128, we)) {
			if (buf[0] == '#' || buf[0] == ' ' || buf[0] == '\n') continue;
			p = strchr (buf, ',');
			*p = '\0';
			a = atoi (buf);
			p1 = strchr (++p, ',');
			*p1 = '\0';
			b = atoi (p);
			p = strchr (++p1, ',');
			*p = '\0';
			c = atoi (p1);
			if ((p1=strchr (++p, '\n'))) *p1 = '\0';
			d = atoi (p);
			if (a == al && b == bl && c == cl && d == dl) continue;
			al = a;
			bl = b;
			cl = c;
			dl = d;
			
			switch (j) {
				case 1:
					if (a == i)
						WYP;
					break;
				case 2:
					if (b == i)
						WYP;
					break;
				case 3:
					if (c == i)
						WYP;
					break;
				case 4:
					if (d == i)
						WYP;
					break;
				default:
					fputs ("shit\n", stderr);
					exit (5);
			}

		}
	}
	
	fclose (we);
	fclose (wy);
	return 0;
}
